{
  //TFile *f = new TFile("../root/c11li6n14pd_sim001.root");

  Char_t label[50] = "c11li6n14pd";
  Char_t simnum[10] = "sim008";

  {
    gStyle->SetStatW(0.3);
    gStyle->SetStatH(0.3);
    gStyle->SetStatFont(62);
    gStyle->SetLabelFont(62,"XY");
    gStyle->SetLabelSize(0.06,"XY");
    gStyle->SetTitleFont(62,"XY");
    gStyle->SetTitleSize(0.06,"XY");
    gStyle->SetTextFont(62);
    gStyle->SetTextSize(0.06);
  }
  
  TCut pscut50 = "abs(p.spc)<50.";
  TCut pscut30 = "abs(p.spc)<30.";
  Int_t color50 = kOrange-3;
  Int_t color30 = kRed;
  
  {
    TCanvas *c1=new TCanvas("c1","",1450,0,1200,800);
    c1->Divide(3,2);
    
    c1->cd(1);
    sim->Draw("E.rel[0]:E.rel[2]>>h11(80,0,6,40,0,6)","","");
    sim->SetMarkerColor(color50);
    sim->Draw("E.rel[0]:E.rel[2]",pscut50,"same");
    sim->SetMarkerColor(color30);
    sim->Draw("E.rel[0]:E.rel[2]",pscut30,"same");
    sim->SetMarkerColor(kBlack);
    
    c1->cd(2);
    sim->Draw("E.lab[1]:E.lab[0]>>h12(80,0,12,40,0,9)","","");
    sim->SetMarkerColor(color50);
    sim->Draw("E.lab[1]:E.lab[0]",pscut50,"same");
    sim->SetMarkerColor(color30);
    sim->Draw("E.lab[1]:E.lab[0]",pscut30,"same");
    sim->SetMarkerColor(kBlack);
    
    c1->cd(3);
    sim->Draw("th.lab[1]:th.lab[0]>>h13(80,0,25,40,0,180)","","");
    sim->SetMarkerColor(color50);
    sim->Draw("th.lab[1]:th.lab[0]",pscut50,"same");
    sim->SetMarkerColor(color30);
    sim->Draw("th.lab[1]:th.lab[0]",pscut30,"same");
    sim->SetMarkerColor(kCyan);
    sim->SetMarkerStyle(6);    
    sim->Draw("th.lab[1]:th.lab[0]","hit.both","same");
    sim->SetMarkerColor(kBlack);
    sim->SetMarkerStyle(1);    

    c1->cd(4);
    sim->Draw("E.cm:abs(p.spc)>>h14(80,0,200,40,-3,3)","","");
    sim->SetMarkerColor(color50);
    sim->Draw("E.cm:abs(p.spc)",pscut50,"same");
    sim->SetMarkerColor(color30);
    sim->Draw("E.cm:abs(p.spc)",pscut30,"same");
    sim->SetMarkerColor(kBlack);

    c1->cd(5);
    sim->SetMarkerColor(kBlack);
    sim->SetLineColor(kBlack);
    sim->Draw("E.cm>>h15(100,-1.5,3)",pscut50*"w.evt","E");
    sim->SetMarkerColor(color50);
    sim->SetLineColor(color50);
    sim->Draw("E.cm",pscut50*"hit.both&&w.evt","Esame");
    sim->SetMarkerColor(color30);
    sim->SetLineColor(color30);
    sim->Draw("E.cm",pscut30*"hit.both&&w.evt","Esame");
    gStyle->SetStatX(0.4);
    sim->SetLineColor(kBlack);

    c1->cd(6);
    sim->SetMarkerColor(color50);
    sim->Draw("th.cm:E.cm>>h16(100,-1.5,3,100,0,180)",pscut50*"w.evt");
    sim->SetMarkerColor(kCyan);
    sim->SetMarkerStyle(7);    
    sim->Draw("th.cm:E.cm>>h16(100,-1.5,3,100,0,180)",
	      pscut50*"w.evt*hit.both","same");
    sim->SetMarkerColor(kBlack);
    sim->SetMarkerStyle(1);    
    gStyle->SetStatX(0.9);

  } //return;


  {
    TCanvas *c2=new TCanvas("c2","",1600,50,1600,800);
    c2->Divide(4,2);
    
    // E.lab
    c2->cd(1);
    sim->Draw("E.lab_det[0]:(E.lab_det_MC[0] - E.lab_det[0])"
  	      ">>h21(80,-0.3,0.3,40,0,12)","hit.both","");
    c2->cd(5);
    sim->Draw("E.lab_det_MC[0] - E.lab_det[0]"
  	      ">>h23(100,-0.3,0.3)","hit.both");

    c2->cd(2);
    sim->Draw("E.lab_det[1]:(E.lab_det_MC[1] - E.lab_det[1])"
  	      ">>h22(80,-0.3,0.3,40,0,10)","hit.both","");
    c2->cd(6);
    sim->Draw("E.lab_det_MC[1] - E.lab_det[1]"
  	      ">>h24(100,-0.3,0.3)","hit.both");

    // th.lab
    c2->cd(3);
    sim->Draw("th.lab[0]:(th.lab_MC[0] - th.lab[0])"
  	      ">>h25(80,-3,3,40,0,30)","hit.both");
    c2->cd(7);
    sim->Draw("th.lab_MC[0] - th.lab[0]"
  	      ">>h27(100,-3,3)","hit.both");
    c2->cd(4);
    sim->Draw("th.lab[1]:(th.lab_MC[1] - th.lab[1])"
  	      ">>h26(80,-3,3,40,0,70)","hit.both");
    c2->cd(8);
    sim->Draw("th.lab_MC[1] - th.lab[1]"
  	      ">>h28(100,-3,3)","hit.both");
  } // return;

  {
    TCanvas *c3=new TCanvas("c3","",1750,100,1600,800);
    c3->Divide(4,2);
    
    // pos.xhit
    c3->cd(1);
    // sim->Draw("pos.xhit:(pos.xhit_MC - pos.xhit)"
    // 	      ">>h31(200,-4.,4.,200,-30,30)","hit.both","colz");    
    sim->Draw("pos.xhit_MC:pos.xhit"
  	      ">>h31(100,-30.,30.,100,-30,30)","hit.both","colz");
    gStyle->SetStatY(0.);
    c3->cd(5);
    sim->Draw("pos.xhit_MC - pos.xhit"
  	      ">>h33(100,-3.,3.)","hit.both&&abs(pos.xhit)<30");

    // pos.yhit
    c3->cd(2);
    sim->Draw("pos.yhit_MC:pos.yhit"
  	      ">>h32(100,-30.,30.,100,-30,30)","hit.both","colz");
    c3->cd(6);
    sim->Draw("pos.yhit_MC - pos.yhit"
  	      ">>h34(100,-3.,3.)","hit.both&&abs(pos.yhit)<30");
    
    // pos.*tar
    sim->SetMarkerStyle(7);
    c3->cd(3);
    sim->Draw("pos.ytar:pos.xtar"
  	      ">>h35(80,-40,40,40,-40,40)","","colz");
    gStyle->SetStatY(0.9);
    c3->cd(4);
    sim->Draw("pos.ytar:pos.ytar_MC-pos.ytar"
  	      ">>h36(80,-5,5,40,-40,40)","","colz");
    c3->cd(7);
    sim->Draw("pos.xtar_MC-pos.xtar:pos.xtar"
  	      ">>h37(80,-40,40,40,-5,5)","","colz");
    sim->SetMarkerStyle(1);
  } //return;


  {
    TCanvas *c4=new TCanvas("c4","",1750,150,1600,800);
    c4->Divide(4,2);
    
    // E.beam
    c4->cd(1);
    sim->Draw("E.beam_dec:(E.beam_mid - E.beam_dec)"
  	      ">>h41(80,-1.,1.,40,10,12)","","");
    c4->cd(5);
    sim->Draw("E.beam_mid - E.beam_dec"
  	      ">>h45(100,-1.,1.)","");

    // E.rel[0]
    c4->cd(2);
    sim->Draw("E.rel[0]:(E.rel_MC[0] - E.rel[0])"
  	      ">>h42(80,-0.6,0.6,40,0,6)","hit.both","");
    c4->cd(6);
    sim->Draw("E.rel_MC[0] - E.rel[0]"
  	      ">>h46(100,-0.6,0.6)","hit.both");

    // E.rel[1]
    c4->cd(3);
    sim->Draw("E.rel[1]:(E.rel_MC[1] - E.rel[1])"
  	      ">>h43(80,-0.6,0.6,40,0,6)","hit.both","");
    c4->cd(7);
    sim->Draw("E.rel_MC[1] - E.rel[1]"
  	      ">>h47(100,-0.6,0.6)","hit.both");

    // E.rel[2]
    c4->cd(4);
    sim->Draw("E.rel[2]:(E.rel_MC[2] - E.rel[2])"
  	      ">>h44(80,-0.6,0.6,40,0,6)","hit.both","");
    c4->cd(8);
    sim->Draw("E.rel_MC[2] - E.rel[2]"
  	      ">>h48(100,-0.6,0.6)","hit.both");


  } //return;

  
  {
    TCanvas *c5=new TCanvas("c5","",1900,200,1200,800);
    c5->Divide(3,2);
    
    // E.cm
    c5->cd(1);
    sim->Draw("E.cm:(E.cm_MC - E.cm)"
  	      ">>h51(80,-0.3,0.3,40,-3,3)","hit.both","");
    c5->cd(4);
    sim->Draw("E.cm_MC - E.cm"
  	      ">>h54(100,-0.3,0.3)","hit.both");
    sim->SetLineColor(color50);
    sim->Draw("E.cm_MC - E.cm>>h54_2",pscut50*"hit.both","same");
    // h54_2->Fit("gaus");
    // gStyle->SetOptFit(1);
    // h54_2->Draw("same");
    sim->SetLineColor(kBlack);
      
    // th.cm
    c5->cd(2);
    sim->Draw("th.cm:(th.cm_MC - th.cm)"
  	      ">>h52(80,-10,10,40,0,180)","hit.both");
    c5->cd(5);
    sim->Draw("th.cm_MC - th.cm"
  	      ">>h55(100,-10,10)","hit.both");
    sim->SetLineColor(color50);
    sim->Draw("th.cm_MC - th.cm",pscut50*"hit.both","same");
    sim->SetLineColor(kBlack);
    
    // Q value
    c5->cd(3);
    sim->Draw("E.Q3_mid>>h53(80,0.,3.)");
    c5->cd(6);
    sim->Draw("E.Q3_dec>>h56(80,0.,3.)");
    
  } //return;

  Char_t fname[100];
  sprintf(fname,"pics/%s_%s_kin.png",label,simnum);
  c1->Update();
  c1->Print(fname);
  sprintf(fname,"pics/%s_%s_lab.png",label,simnum);
  c2->Update();
  c2->Print(fname);
  sprintf(fname,"pics/%s_%s_pos.png",label,simnum);
  c3->Update();
  c3->Print(fname);
  sprintf(fname,"pics/%s_%s_rel.png",label,simnum);
  c4->Update();
  c4->Print(fname);
  sprintf(fname,"pics/%s_%s_cm.png",label,simnum);
  c5->Update();
  c5->Print(fname);
  
}
