#include <TGeoManager.h>
#include <TGeometry.h>
#include <TNode.h>
#include <TGeoVolume.h>
#include <TGeoMatrix.h>
#include <TGeoMedium.h>
#include <TGeoMaterial.h>
#include <TGeoNode.h>
#include <TMaterial.h>
#include <TMixture.h>
#include <TShape.h>
#include <TString.h>
#include <Riostream.h>
#include <TFile.h>
#include <TCanvas.h>
#include <TH2F.h>
#include <TMath.h>
#include <TLorentzVector.h>
#include <TSystem.h>
#include <stdlib.h>
#include <TROOT.h>
#include <TGenPhaseSpace.h>
#include <TStyle.h>
#include "TGeoPatternFinder.h"
#include "TSystem.h"
#include <TGeoNavigator.h>
#include <iostream>
#include <cstdlib>
#include <fstream>
#include <cmath>
#include "TApplication.h"
#include "TF1.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TH1.h"
#include "TLegend.h"
#include "TLegendEntry.h"
#include "TColor.h"
#include <TRandom3.h>
#include <TTree.h>
#include <time.h> // for the seed of the dandom number
#include <TView3D.h>

#include "Math/Interpolator.h"
//#include "Math/Polynomial.h"
#include "Math/InterpolationTypes.h"
//#include "Math/Types.h"

#include "prm_reac.C" // parameter file <--

using namespace std;

extern "C" {
  void enewzsub_etot_(int *z1, float *m1, float *bfr_ene, char matter1[33], 
		      int *unit_pressure, float *pressure, float *temperature, 
		      int *unit_thick, float *thick1, float *aft_ene);
  void eoldzsub_etot_(int *z1, float *m1, float *aft_ene, char matter1[33], 
		      int *unit_pressure, float *pressure, float *temperature, 
		      int *unit_thick, float *thick1, float *bfr_ene);
  void rangezsub_etot_(int *z1, float *m1, float *bfr_ene, char matter1[33], 
		       float *range);
  void srhogas_(float *pressure, float *temperature, int *unit_pressure,
		int *unit_temperature, float *mol_weight, 
		float *density);
}

// effective thickness //
// Double_t eff_thk(Double_t x ){ // beam energy in GeV
//   for(Int_t ichar=0;ichar<33;ichar++){ 
//     if(he[ichar]=='\0'){
//       he[ichar]=' ';
//       he[ichar+1]='\0';
//     }
//   }
  
//   //float dxpu = dEbin*(m26si + ma)/m26si/ma; // energy bin size in AMeV
//   float dxpu = dEbin*(mprj + mtrg)/mprj/mtrg; // energy bin size in AMeV
//   float xpu;
//   float range1, range2, drange;

//   xpu = x*1000./mprj + dxpu/2.;
//   rangezsub_(&zprj,&mprj,&xpu,he,&range1);
//   xpu = x*1000./mprj - dxpu/2.;
//   rangezsub_(&zprj,&mprj,&xpu,he,&range2);

//   drange = fabs(range1 - range2);
//   //cout << x*1000. << " " << range2 << " " << range1 << " " << drange << endl;
  
//   return(drange);
// }

// Double_t dtof(Double_t *x, Double_t *p){
//   for(Int_t ichar=0;ichar<33;ichar++){ 
//     if(he[ichar]=='\0'){
//       he[ichar]=' ';
//       he[ichar+1]='\0';
//     }
//   }

//   int z = int(p[0]);
//   float m = float(p[1]);
//   //float ebpu = float(p[2]);
//   float eb = float(p[2]);
//   float l = float(x[0]);
//   // to be integrated: dtof = dx/v(x)
//   //float eapu; // MeV
//   float ea; // MeV
//   // enewzsub_(&z, &m, &ebpu, he, &unit_pressure, &pressure, 
//   // 	    &temperature, &unit_mm, &l, &eapu);
//   enewzsub_etot_(&z, &m, &eb, he, &unit_pressure, &pressure, 
// 	    &temperature, &unit_mm, &l, &ea);
//   // cout << z << " " << m << " " << ebpu << " " << l << " " << eapu << endl;
//   // getchar();
//   return sqrt(u*m*1000./2./ea)/c;
// }

/* Double_t Elab2cm(Double_t Elab, Double_t thlab, */
/* 		 Double_t mres_ex, Double_t q2ex){ */
/*   Double_t A = mtrg*(mprj + mtrg)/mprj/mrec*Elab; */
/*   Double_t B = mtrg*mres_ex/mprj/mrec; */
/*   Double_t D = 1. - B; */
/*   Double_t C = 2.*pow(cos(thlab*d2r),2) - D; // 1. - B; */
/*   // cout << A <<" "<< B  <<" "<< C <<" "<< D << endl; */
/*   //cout << q2 <<" "; */
  
/*   Double_t Ecm; */
/*   //cout << q2ex << endl; */
/*   if(q2ex > 5.e-7){ */
/*     Ecm= ( A*C + B*q2ex*D*1000. - 2.*cos(thlab*d2r) */
/* 	   *sqrt( A*(A*(B - pow(sin(thlab*d2r),2)) + B*q2ex*D*1000.) ) ) */
/*       /D/D; */
/*   }else{ // Q = 0, elastic scattering */
/*     Ecm = (mtrg + mprj)/4./mprj/pow(cos(thlab*d2r),2)*Elab; */
/*   } */
/*   // Double_t Ecm = ( A*C + B*q2ex*D - 2.*cos(thlab*d2r) */
/*   // 		   *sqrt( A*(A*(B - pow(sin(thlab*d2r),2)) + B*q2ex*D) ) )/D/D; */
/*   //cout << Elab <<" "<< thlab<< " " <<Ecm <<endl ; */
/*   //getchar(); */

/*   // if(isnan(abs(Ecm))){ */
/*   //   cout << thlab << " " << A << " " << B << " " << C << " " << D << " " */
/*   //     //<< A*(B - pow(sin(thlab*d2r),2)) << " " << B*q2ex*D*1000. */
/*   // 	 << pow(sin(thlab*d2r),2) << " " << B - pow(sin(thlab*d2r),2) */
/*   // 	 << endl; */
/*   //   getchar(); */
/*   // } */
/*   return Ecm; */
/* } */

/* Double_t thlab2cm(Double_t Ecm, Double_t thlab, */
/* 		  Double_t mres_ex, Double_t q2ex){ */
/*   Double_t g = sqrt(mprj*mrec*Ecm/mtrg/mres_ex/(Ecm + q2ex)); */
/*   Double_t thcm; // = atan( (tan(thlab*d2r) */
/*   //	 *(1. + g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)))) */
/*   //			/ (1 - g*g*pow(tan(thlab*d2r),2)) )/d2r; */
/*   // Double_t thcm_p = atan( (tan(thlab*d2r) */
/*   // 			   *(1. + g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)))) */
/*   // 			  / (1 - g*g*pow(tan(thlab*d2r),2)) )/d2r; */
/*   // Double_t thcm_m = atan( (tan(thlab*d2r) */
/*   // 			   *(1. - g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)))) */
/*   // 			  / (1 - g*g*pow(tan(thlab*d2r),2)) )/d2r; */
/*   //if(thcm < 0.) thcm += 180.; */
/*   //cout << g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)) << endl; */
/*   //if(1. - g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)) < 0.){ */
/*   // if(1. - g*g*pow(tan(thlab*d2r),2) > 0.){ */
/*   thcm = atan( (tan(thlab*d2r) */
/* 		*(1. + g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)))) */
/* 	       / (1 - g*g*pow(tan(thlab*d2r),2)) )/d2r; */

/*   if(thcm < 0) */
/*     thcm += 180.; */
/*   // }else{ */
/*   //   thcm = atan( (tan(thlab*d2r) */
/*   // 		  *(1. + g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)))) */
/*   // 		 / (1. - g*g*pow(tan(thlab*d2r),2)) )/d2r; */
/*   // } */
/*   // cout << thlab << " " */
/*   //      << 1. + g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)) << " " */
/*   //      << 1. - g*sqrt(1. +(1. -g*g)*pow(tan(thlab*d2r),2)) << " " */
/*   //      << (1. - g*g*pow(tan(thlab*d2r),2)) << " " */
/*   //      << thcm <<  endl; */

/*   // cout << sin(thcm_p*d2r) << " " */
/*   //   	 << cos(thcm_p*d2r) << " " */
/*   // 	 << sin(thcm_m*d2r) << " " */
/*   //   	 << cos(thcm_m*d2r) << " " */
/*   // 	 << sin(thcm_p*d2r)/(cos(thcm_p*d2r)+g) << " " */
/*   // 	 << sin(thcm_m*d2r)/(cos(thcm_m*d2r)+g) << " " */
/*   // 	 << tan(thlab*d2r) << endl; */
    
/*   return thcm; */
/* } */

/* Double_t ebeam2thk(Double_t Ebeam, Double_t Ebeam_ini){ //at z & entrance */
/*   for(Int_t ichar=0;ichar<33;ichar++){  */
/*     if(he[ichar]=='\0'){ */
/*       he[ichar]=' '; */
/*       he[ichar+1]='\0'; */
/*     } */
/*   } */
  
/*   //float xpu; */
/*   float x; */
/*   float range1, range2, drange; */

/*   // xpu = Ebeam/mprj; // MeV/u */
/*   // rangezsub_(&zprj,&mprj,&xpu,he,&range1); */
/*   // xpu = Ebeam_ini/mprj;// MeV/u */
/*   // rangezsub_(&zprj,&mprj,&xpu,he,&range2); */
/*   x = Ebeam; // MeV/u */
/*   rangezsub_etot_(&zprj,&mprj,&x,he,&range1); */
/*   x = Ebeam_ini;// MeV/u */
/*   rangezsub_etot_(&zprj,&mprj,&x,he,&range2); */

/*   drange = range2 - range1; // mg/cm^2 */
  
/*   return(drange); */
/* } */

Double_t sgm_ppac_ab(Double_t z){  
  //Double_t sgm = sgm_ppac*sqrt(pow((zab-z)/zab,2) + pow(z/zab,2));
  // Double_t sgm = sgm_ppac*sqrt(pow((zb-z)/(zb-za),2)
  // 			       + pow((za-z)/(zb-za),2));
  Double_t sgm = sqrt(pow((zb-z)/(zb-za),2)*sgm_ppac_a
		      + pow((za-z)/(zb-za),2)*sgm_ppac_b);
  return sgm;
};

Double_t theta_cm(Double_t mprj, Double_t mtrg, TLorentzVector beam, TLorentzVector plrz3, TVector3 vel[3]){
  TVector3 vprj = pow(u*mprj,-1)/beam.Gamma() *(beam.Vect()); // velocity 
  TLorentzVector ptran = - plrz3; // 4-momentum of the transferred particle 
  TVector3 vtran = 1./sqrt(pow(mtrg*u - plrz3.Energy(),2) + plrz3.Mag2())
    /ptran.Gamma() *ptran.Vect(); // velocity, See Slaus et al
  TVector3 ki = vprj - vtran; // target breakup 13-11-2017
  TVector3 kf = vel[0] - vel[1]; // Final relative velocity (1<->2); vel[0] is beamlike (heavy ion)
  return (ki.Angle(kf))/d2r;  
}

Double_t mom_spec(TVector3 pmom){
  Double_t scp;
  if( cos(pmom.Phi())>0 ) // x>0 direction
    scp=1;
  else if ( cos(pmom.Phi())<0 ) // x<0 direction
    scp=-1.;
  else 
    scp=0.;
  return pmom.Mag()*scp*1000.; // in MeV/c target breakup
}

/* void init_struct(){ */
/* } */

Double_t strip_position(Double_t x, Int_t n_strip, Double_t psd_half){
  Double_t x_strip = x;
  Double_t w_strip = psd_half*2./double(n_strip); // strip width
  Double_t x0 = - psd_half;
  Double_t x1 = x0 + w_strip;
  for(Int_t i=0; i<n_strip; i++){
    if(x > x0 && x <= x1){
      x_strip = (x0 + x1)/2.;
      break;
    }
    x0 = x1;
    x1 += w_strip; 
  }
  //cout << x << " " << x_strip << " " << endl;
  return x_strip;
}

int main() { 
  TApplication theApp("App", NULL, NULL);
  //ROOT::Math::IntegratorOneDimOptions::SetDefaultIntegrator("Gauss");
  
  // For enewz
  for(Int_t ichar=0;ichar<33;ichar++){ 
    if(he[ichar]=='\0'){
      he[ichar]=' ';
      he[ichar+1]='\0';
    }
    if(si[ichar]=='\0'){
      si[ichar]=' ';
      si[ichar+1]='\0';
    }
    if(lif[ichar]=='\0'){
      lif[ichar]=' ';
      lif[ichar+1]='\0';
    }
  }
  //float density = 5.4743e-05; // of the target gas (g/cm^3)
  // srhogas_(&pressure, &temperature, &unit_pressure,
  // 	   &unit_temperature, &ma, 
  // 	   &density);
  // cout << density << endl; getchar();
  
  // For TOF integration
  //TF1 *fint = new TF1("fint",dtof,0.,ltar,3);
  
  /* // NON-SMOKER data */
  /* const Int_t nhf = 90; // no. of data */
  /* Double_t ehf[nhf], notused, cshf[nhf]; */
  /* ifstream datahf("../../../nonsmoker_cs.txt");  */
  /* for(Int_t i=0; i<nhf; i++ ){ // i=1 to avoid the 1st row */
  /*   datahf >> ehf[i] >> notused >> notused >> cshf[i]; */
  /*   //cout << i << " " << ehf[i] <<" "<< cshf[i] << endl; */
  /* } */
  /* //getchar(); */
  /* datahf.close(); */
  /* ROOT::Math::Interpolator interhf(nhf, ROOT::Math::Interpolation::kLINEAR); */
  /* interhf.SetData(nhf, ehf, cshf); */

  // to store the parameter file
  gROOT->ProcessLine(Form(".! cp -pv prm_reac.C prm/prm_reac.%s_%s.C",
			  label,simnum));
  Char_t fname[200];
  sprintf(fname,"root/%s_%s.root",label,simnum);
  cout << "Output file name: " << fname << endl;
  cout << "OK to run?" << endl; getchar();
  TFile *fl2 = new TFile(fname,"RECREATE");
  TTree* sim = new TTree("sim","");

  // variables for tree
  // E.beam_ini: initial beam energy before target (deviated when deprj!=0)
  // E.beam_mid: beam energy at the middle of the target
  // E.beam_dec: beam energy at arbitrary target depth
  typedef struct{
    Double_t beam_mid, beam_mid_MC, beam_dec; //beam_ini, 
    Double_t lab[3], lab_det[2], lab_det_MC[2], lab_MC[3];
    //Double_t lab_DE[2], lab_DE_MC[2], lab_RES[2], lab_RES_MC[2];
    Double_t rel[3], rel_MC[3], cm, cm_MC; //cm_z, cm_MC, cm_z_MC, cm_z0, cm_dev;
    Double_t Q3_mid, Q3_dec; // 3-body Q-value
  } ENERGY;
  ENERGY E;
  sim->Branch("E",&E,"beam_mid/D:beam_mid_MC:beam_dec:" //beam_ini/D:
	      "lab[3]:lab_det[2]:lab_det_MC[2]:lab_MC[3]:"
	      //"lab_DE[2]:lab_DE_MC[2]:lab_RES[2]:lab_RES_MC[2]:"
	      "rel[3]:rel_MC[3]:cm:cm_MC:Q3_mid:Q3_dec");
  
  typedef struct{
    Double_t lab[3], lab_MC[3], cm, cm_MC, cm_dev, cm_MC_nr;
  } THETA;
  THETA th;
  sim->Branch("th",&th,"lab[3]/D:lab_MC[3]:cm:cm_MC:cm_dev:cm_MC_nr");

  typedef struct {
    Double_t lab[3], lab_MC[3]; 
  } PHI;
  PHI phi;
  sim->Branch("phi",&phi,"lab[3]/D:lab_MC[3]");

  typedef struct {
    Double_t spc, spc_MC; 
  } MOMENTUM;
  MOMENTUM p;
  sim->Branch("p",&p,"spc/D:spc_MC");

  typedef struct {
    Double_t xtar, ytar, rtar;
    Double_t ztar;
    Double_t xtar_MC, ytar_MC, rtar_MC; //, ztar0, ztar_MC;
    //Double_t ldetprt[2], ldetprt_MC[2];
    Double_t xhit[2][ndet], yhit[2][ndet], xhit_MC[2][ndet], yhit_MC[2][ndet];  
  } POSITION;
  POSITION pos;
  sim->Branch("pos",&pos,
	      Form("xtar/D:ytar:rtar:ztar:"
		   "xtar_MC:ytar_MC:rtar_MC:" //ztar0:ztar_MC:"
		   //		   "ldetprt[2]:ldetprt_MC[2]:"
		   "xhit[2][%d]:yhit[2][%d]:"
		   "xhit_MC[2][%d]:yhit_MC[2][%d]",
		   ndet,ndet,ndet,ndet)
	      );

  // typedef struct {
  //   //Double_t de, e, beam, rec, dee, de_MC, e_MC, beam_dec, rec_MC;
  //   Double_t beam, beam_dec, rec, rec_MC, de, de_MC;
  // } TOF;
  // TOF tof;
  // sim->Branch("tof",&tof,"beam/D:beam_dec:rec:rec_MC:de:de_MC");
  
  typedef struct{
    Int_t idet[2]; // for particle 1&2
    Bool_t any;
    Bool_t both;
    //Int_t any,idet;
  } HIT;
  HIT hit;
  //sim->Branch("hit",&hit,"any/O:idet/I");
  sim->Branch("hit",&hit,"idet[2]/I:any/O:both/O");
  // Bool_t any;
  // Int_t idet;
  // sim->Branch("any",&any,"any/O");
  // sim->Branch("idet",&idet,"idet/I");

  // typedef struct{
  //   Double_t prs, prs0, tmp, tmp0;
  // } GAS;
  // GAS gas;
  // sim->Branch("gas",&gas,"prs/D:prs0:tmp:tmp0");
  
  typedef struct {
    Double_t evt; //, efth, hf, yld;
  } WEIGHT;
  WEIGHT w;
  sim->Branch("w",&w,"evt/D"); //:efth:hf:yld");
  //
  Int_t iex;
  sim->Branch("iex",&iex,"iex/I");  
  for(Int_t iexci=0; iexci<Nexci; iexci++){ // define mass and q value for excited states
    mres[iexci] = mres_gs + exci[iexci]/u/1000.; // (a,p) 
    q2[iexci] = (mprj + mprt - mres[iexci] - mrec)*u; 
    //cout << i <<" " <<mres[i] <<" "<< q2[i] << endl;
  }
  //getchar();

  //////////////////////////////////////
  
  gStyle->SetPalette(1);
  gSystem->Load("libPhysics.so");
  gSystem->Load("libGeom.so");    
  TGeoManager *sc = new TGeoManager("scattcham","Scattering Chamber");    
  TGeoMaterial *matVacuum = new TGeoMaterial("Vacuum",0,0,0);
  TGeoMaterial *matSi = new TGeoMaterial("Si",28.086,14,2.321);    
  TGeoMedium *Vacuum = new TGeoMedium("Vacuum",1,matVacuum);
  TGeoMedium *Si = new TGeoMedium("Root Material",2,matSi);    
  TGeoVolume *top = sc->MakeSphere("TOP",Vacuum,0.,r_sphere,0.,180.,0.,360.); //mm
  sc->SetTopVolume(top);    
  TGeoVolume *psd[ndet];
  // (X,Y,Z,rotation angle theta originating at (X,Y,Z) )
  // tan(theta) = X/Z
  // TGeoCombiTrans *pos1 = new TGeoCombiTrans(12.28,0,16.29,new TGeoRotation("rot1",90,37,0));
  // TGeoCombiTrans *pos2 = new TGeoCombiTrans(-4.788,0,13.16,new TGeoRotation("rot2",90,-20,0));
  
  TGeoCombiTrans *posdet[ndet];
  Char_t rotname[10];
  TVector3 vdet[ndet], voff[ndet];
  
  // Detectors 
  for(Int_t idet=0; idet<ndet; idet++){
    psd[idet] = sc->MakeBox("PSD",Si,psd_half[idet],psd_half[idet],0.5); // in mm // 03-04-2018
    vdet[idet].SetXYZ( ldet[idet]*sin(d2r*thdet[idet])+xdet_off[idet],
		    0,ldet[idet]*cos(d2r*thdet[idet])+zdet_off[idet] );
    //dth[idet] = atan(psd_half/ldet[idet])/d2r;
    sprintf(rotname,"rot%d",idet);
    posdet[idet] = new 
      // Rotate detectors
      //TGeoCombiTrans(ldet[idet]*sin(d2r*thdet[idet]),0,ldet[idet]*cos(d2r*thdet[idet]),
      // TGeoCombiTrans(ldet[idet]*sin(d2r*thdet[idet])+xdet_off[idet],
      // 		     0, ldet[idet]*cos(d2r*thdet[idet])+zdet_off[idet],
      // 		     new TGeoRotation(rotname,90,thdet[idet],0));
      TGeoCombiTrans(vdet[idet].X(),vdet[idet].Y(),vdet[idet].Z(),
		     new TGeoRotation(rotname,90,thdet[idet],0));
    // Put detectors at coordinates 
      // TGeoCombiTrans(xdet[idet],0.,zdet[idet], new TGeoRotation(rotname,90,rotdet[idet],0));
    top->AddNode(psd[idet],idet,posdet[idet]);
    voff[idet].SetXYZ(xdet_off[idet],0.,zdet_off[idet]);
    //strip_half[idet] = psd_half[idet]/n_strip[idet]; //13-10-2021
    //strip_half[idet] = 0.; //sim001, sim002
  }
  
  gGeoManager->CloseGeometry();
  top->SetLineColor(kRed);
  gGeoManager->SetTopVisible();    
  
  ///////////////////////////////////////////////////////////////  
  TVector3 vhit[2][ndet];
  TVector3 vhit_MC[2];
  TVector3 vdec_det[2], vmid_det_MC[2]; // paticle #1 #2

  TLorentzVector plrz[3], plrz_MC[3];
  TVector3 pmom[3], pmom_MC[3]; // particle #1, #2
  TVector3 pdir[2];
  TLorentzVector plrzsum[3], plrzsum_MC[3]; // #1+#2, #2+#3, #3+#1
  TVector3 vel[3], vel_MC[3];
  
  TCanvas *c0 = new TCanvas("c0","c0",1450,0,800,800);
  top->Draw();
  c0->Update();
  gSystem->ProcessEvents();
  
  TLorentzVector target(0.0, 0.0, 0.0, u*mtrg); // px, py, pz, e
  TGenPhaseSpace event;

  Int_t seed = time(NULL);
  TRandom3* ran = new TRandom3(seed); //

  Long64_t i = 0;
  Long64_t geve=0;
  Long64_t nstep = ntot/4321;

  printf("%6.2f %% done, %6.2f %% valid \r",
  	 float(i)/float(ntot)*100.,
  	 float(geve)/float(i)*100.);     

  ///////////////////////////////////////////////////////////////
  for(Int_t ievt=0; ievt<ntot; ievt++){
    // to show the process //
    if(ievt%nstep == 0) 
      printf("%6.2f %% done, %6.2f %% valid \r",
    	     float(ievt)/float(ntot)*100.,
    	     float(geve)/float(ievt)*100.);     

    // Initialization of structures //
    /* (Tell me if you know any better way of initialization of 
     structures with non-0 values) */
    E = {dummy, dummy, dummy, dummy,dummy,dummy, dummy,dummy,
    	 dummy,dummy, dummy,dummy,dummy, dummy,dummy,dummy,
    	 dummy,dummy,dummy, dummy, dummy, dummy, dummy};
    //E = {0};
    th = {0};
    p = {dummy,dummy};
    //p = {0};
    //tof = {dummy};
    hit.idet[0] = hit.idet[1] = -1;
    hit.any = hit.both = false;
    pos = {dummy,dummy,dummy,dummy,
    	   dummy,dummy,dummy,
	   dummy,dummy, dummy,dummy, dummy,dummy,
	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy,
    	   dummy,dummy, dummy,dummy, dummy,dummy};
    //pos = {0};
    //pos.ztar = 0.; //pos.ztar0 = pos.ztar_MC = 0.; // z = 0 is the target position
    w = {0};
    iex = -1;
    
    // Definition of the excited state in 13N
    iex = ran->Rndm()*Nexci; // 0-1 * Nexci
    Double_t mass[3] = { u*mres[iex], u*mrec, u*mspc} ; // masses of 14N, p, d
    
    // Definition of beam energy
    // Monte Carlo reaction depth in target
    // |---x---| _mid Reference: middle -> E.beam_mid
    // |---x---| _mid_MC with spread: middle -> E.beam_mid_MC
    // |---|-x-| _dec Practice: -1/2 thk_tar -- +1/2 thk_tar -> E.beam_dec
    // -1------1
    E.beam_mid = eprj_mid*1000.; // defined energy at middle
    E.beam_mid_MC = ran->Gaus(eprj_mid,deprj)*1000.; // energy at middle with initial beam spread 
    float fthk_mid_dec = thk_tar/2.*ran->Uniform(-1.,1.); // distance from the middle
    Ebfr = E.beam_mid_MC;
    enewzsub_etot_(&zprj, &mprj, &Ebfr, lif, &unit_pressure, &pressure,
    	      &temperature, &unit_mgpcm2, &fthk_mid_dec, &Eaft);    
    E.beam_dec = Eaft;
    //cout << E.beam_mid << " " << E.beam_dec << " " << fthk_dec << endl;
    //    E.beam_dec = Ebfrpu*mprj;

    // Beam hitting position
    pos.xtar = ran->Gaus(xtar0,xtar0_sgm);
    pos.ytar = ran->Gaus(ytar0,ytar0_sgm);
    pos.ztar = 0.;
    pos.rtar = sqrt(pos.xtar*pos.xtar + pos.ytar*pos.ytar);
    //TVector3 vtar(xtar,ytar,0); // vector from origin to target pos.
    TVector3 vdec(pos.xtar,pos.ytar,pos.ztar); // vector to the reaction point.
    // pos.xtar -> pos.xtar_MC
    // pos.ytar -> pos.ytar_MC
    // -> pos.rtar_MC
    Double_t sgm_track = sgm_ppac_ab(pos.ztar);
    pos.xtar_MC = ran->Gaus(pos.xtar,sgm_track);
    pos.ytar_MC = ran->Gaus(pos.ytar,sgm_track);
    pos.rtar_MC = sqrt(pos.xtar_MC*pos.xtar_MC + pos.ytar_MC*pos.ytar_MC);
    TVector3 vmid_MC(pos.xtar_MC,pos.ytar_MC,pos.ztar); // ztar for solid target

    // Beam, compound, decay
    // E^2 = m^2*c^4 + c^2*p^2
    // E = K + m*c^2
    // c*p = sqrt(K^2 + 2*m*c^2*K)
    //TLorentzVector beam_dec(0.0, 0.0, sqrt(2.*u*mprj*E.beam_dec/1000.), u*mprj+E.beam_dec/1000.); // px, py, pz, e
    //TLorentzVector beam_mid(0.0, 0.0, sqrt(2.*u*mprj*E.beam_mid/1000.), u*mprj+E.beam_mid/1000.); // px, py, pz, e
    TLorentzVector beam_dec(0.0, 0.0,
			    sqrt(pow(E.beam_dec/1000.,2) + 2.*E.beam_dec*u*mprj/1000.),
			    u*mprj+E.beam_dec/1000.); // px, py, pz, e
    TLorentzVector beam_mid(0.0, 0.0,
			    sqrt(pow(E.beam_mid/1000.,2) + 2.*E.beam_mid*u*mprj/1000.),
			    u*mprj+E.beam_mid/1000.); // px, py, pz, e
    TLorentzVector W_dec = beam_dec + target; // coumpound of beam + target
    TLorentzVector W_mid = beam_mid + target; // coumpound of beam + target
    event.SetDecay(W_dec, 3, mass); // W: beam + target -> 3-body decay: mres+mrec+m3
    w.evt = event.Generate();
    
    // Decay kinematics
    for(Int_t iprt=0; iprt<3; iprt++){
      plrz[iprt] = *event.GetDecay(iprt); // lorentz vector      
      pmom[iprt] = plrz[iprt].Vect(); // momenta
      vel[iprt] = pow(mass[iprt],-1)/plrz[iprt].Gamma() *pmom[iprt]; // velocity
      th.lab[iprt] = (plrz[iprt].Theta())/d2r;
      phi.lab[iprt] = (plrz[iprt].Phi())/d2r;
      E.lab[iprt] = (plrz[iprt].Energy()-mass[iprt])*1000.; // MeV
    }
    for(Int_t iprt=0; iprt<3; iprt++){ // After plrz[iprt] are all defined...
      plrzsum[iprt] = plrz[iprt] + plrz[(iprt+1)%3]; // (iprt+1)%3 = 1, 2, 0
      E.rel[iprt] = (plrzsum[iprt].M() - (mass[iprt] + mass[(iprt+1)%3]))*1000.; // MeV
    }
    E.cm = E.rel[0] - q2[iex]*1000.; // MeV
    th.cm = theta_cm(mprj, mtrg, beam_dec, plrz[2], vel);   
    p.spc = mom_spec(pmom[2]); // in MeV/c, tartget breakup
    E.Q3_mid = E.lab[0] + E.lab[1] + E.lab[2] - E.beam_mid;
    
    // Tracking decaying particles
    /// Particle 1: residual heavy ion
    /// Particle 2: recoil light particle
    /// Particle 3: spectator
    //Int_t hitdet[2];
    Double_t xx, yy, zz;
    Double_t snext;
    Bool_t istate[2] = {false, false};
    Int_t idnode[2];
    const Char_t *path;
    Char_t sdet[2];
    for(Int_t iprt = 0; iprt<2; iprt++){
      pdir[iprt] = pmom[iprt].Unit(); // Unit vector of the particle motion
      xx = pdir[iprt](0); // Each element of the vector
      yy = pdir[iprt](1);
      zz = pdir[iprt](2);
      gGeoManager->SetCurrentPoint(pos.xtar,pos.ytar,pos.ztar); // Reaction point
      gGeoManager->SetCurrentDirection(xx,yy,zz); // Reaction direction
      gGeoManager->GetCurrentNode();
      gGeoManager->FindNode();
      gGeoManager->FindNextBoundary(r_sphere*2.); // finds distance to next boundary -> fStep
      // for solid target, r_sphere, for gas target, r_sphere*2.
      snext = gGeoManager->GetStep(); // Dist. reaction point <-> detector hit point
      gGeoManager->Step();
      istate[iprt] = gGeoManager->IsStepEntering();
      idnode[iprt] = gGeoManager->GetCurrentNodeId();
      //Double_t safety2 = gGeoManager->GetSafeDistance();
      /* cout << iprt << " " */
      /* 	   << istate[iprt] <<" "<< snext[iprt] <<" " << idnode[iprt] << endl; */
      //const Char_t *path1
      path = gGeoManager->GetPath(); // /TOP_1/PSD_3 etc.
      strncpy(sdet, path+11, 1); // extract the 12th character from pathq
      sdet[1] = '\0';
      //hitdet[iprt] = atoi(sdet); // Number of the hitting
      hit.idet[iprt] = atoi(sdet); // Number of the hitting 
      vdec_det[iprt].SetXYZ(snext*xx,snext*yy,snext*zz); // Vector reaction point <-> detector hit point
      //pos.ldetprt[iprt] = snext; // Dist. reaction point <-> detector hit point
    }
    
    // If particles hit any detectors
    if(istate[0] || istate[1]){
      hit.any = true;
      /* cout << "any" << endl; */
    }
    
    // If both particle 1 & 2 hit different detectors respectively
    if(istate[0] && istate[1] && idnode[0]!=idnode[1]){	      
      hit.both = true;
      //////////////////////
      // Resolution Study //
      //////////////////////
      for(Int_t iprt = 0; iprt<2; iprt++){ // Particle 1 & 2
	//hit.idet[iprt] = hitdet[iprt];
	// Integerization: no. of the hit detector // Warning: when no hit, it returns 0!	
	//vhit[hit.idet] = vtar + vdetprt - vdet[hit.idet] - voff[hit.idet];
	vhit[iprt][hit.idet[iprt]] = vdec_det[iprt] + vdec - vdet[hit.idet[iprt]];
	//vhit[hit.idet] -= voff[hit.idet];
	vhit[iprt][hit.idet[iprt]].RotateY(-d2r*thdet[hit.idet[iprt]]);
	pos.xhit[iprt][hit.idet[iprt]] = vhit[iprt][hit.idet[iprt]].X();
	pos.yhit[iprt][hit.idet[iprt]] = vhit[iprt][hit.idet[iprt]].Y();
	//} // for iprt
	/* cout << iprt << " " ; */
	/* for(Int_t idet=0; idet<ndet; idet++){ */
	/*   cout << pos.xhit[iprt][idet] << " " ; */
	/* } */
	/* cout << endl; */
	//	cout << hit.idet[1] << " " << idnode[1] << endl;
	
	////////////////////////////////////////
	// Energy loss by the target material //
	////////////////////////////////////////
	// E.lab -> E.lab_det
	//for(Int_t iprt = 0; iprt<2; iprt++){
	float fthk_dec_end = (thk_tar/2. - fthk_mid_dec)/cos(th.lab[iprt]*d2r); // Dist. reaction point <-> detector hit      
	Ebfr = E.lab[iprt]; // MeV
	float fmass = mass[iprt];
	enewzsub_etot_(&atom_num[iprt], &fmass, &Ebfr, lif, &unit_pressure, &pressure,
		       &temperature, &unit_mgpcm2, &fthk_dec_end, &Eaft);
	E.lab_det[iprt] = Eaft; // MeV
	//cout << fthk_dec_end <<" "<< Ebfr <<" " << Eaft << endl;	
	//}
      
	//xhit_MC[hit.idet] = ran->Gaus(xhit[hit.idet],dx_det); // !
	//yhit_MC[hit.idet] = ran->Gaus(yhit[hit.idet],dy_det); // !
	//vhit_MC += voff[hit.idet];
	//vdetprt_MC = vdet[hit.idet] - vhit_MC - vdec_MC;
	
	// E.lab_det[0,1] -> E.lab_det_MC[0,1]
	//for(Int_t iprt = 0; iprt<2; iprt++){
	// pos.xhit -> pos.xhit_MC
	/* pos.xhit_MC[iprt][hit.idet[iprt]] */
	/*   = ran->Uniform(pos.xhit[iprt][hit.idet[iprt]]-strip_half[hit.idet[iprt]], */
	/* 		 pos.xhit[iprt][hit.idet[iprt]]+strip_half[hit.idet[iprt]]); // for strip */
	pos.xhit_MC[iprt][hit.idet[iprt]]
	  = strip_position( pos.xhit[iprt][hit.idet[iprt]],
			    n_strip[hit.idet[iprt]],
			    psd_half[hit.idet[iprt]] );
	// pos.yhit -> pos.yhit_MC
	/* pos.yhit_MC[iprt][hit.idet[iprt]] */
	/*   = ran->Uniform(pos.yhit[iprt][hit.idet[iprt]]-strip_half[hit.idet[iprt]], */
	/* 		 pos.yhit[iprt][hit.idet[iprt]]+strip_half[hit.idet[iprt]]); // for strip */
	pos.yhit_MC[iprt][hit.idet[iprt]]
	  = strip_position( pos.yhit[iprt][ hit.idet[iprt] ],
			    n_strip[ hit.idet[iprt] ],
			    psd_half[ hit.idet[iprt] ] );
	vhit_MC[iprt].SetXYZ( pos.xhit_MC[iprt][hit.idet[iprt]],
			      pos.yhit_MC[iprt][hit.idet[iprt]], 0 ); //vector on det. surface
	vhit_MC[iprt].RotateY(d2r*thdet[hit.idet[iprt]]); // Rotate from z axis to det. angle
	E.lab_det_MC[iprt] = ran->Gaus(E.lab_det[iprt], // based on resolution at 5 MeV
				       sqrt(5.*E.lab_det[iprt])*depe2); // MeV
	// vectors from the mid target to the detection point with resolution
	vmid_det_MC[iprt] = vhit_MC[iprt] + vdet[hit.idet[iprt]] - vmid_MC;
	//fldec_det_MC = float(vmid_det_MC.Mag());
	// th.lab_MC
	th.lab_MC[iprt] = (vmid_det_MC[iprt].Theta())/d2r;
	// phi.lab_MC
	phi.lab_MC[iprt] = (vmid_det_MC[iprt].Phi())/d2r;
	Eaft = E.lab_det_MC[iprt];
	float fthk_mid_end_MC = (thk_tar/2.)/cos(th.lab_MC[iprt]*d2r);
	eoldzsub_etot_(&zrec, &mrec, &Eaft, he, &unit_pressure, &pressure,
		       &temperature, &unit_mgpcm2, &fthk_mid_end_MC, &Ebfr);
	// -> E.lab_MC[0,1]
	E.lab_MC[iprt] = Ebfr; // MeV

	// Definition of TLorentzVector // -> plrz_MC[1,0]
	plrz_MC[iprt].SetE(mass[iprt]+E.lab_MC[iprt]/1000.);
	plrz_MC[iprt].SetVect(vmid_det_MC[iprt].Unit()*sqrt(2.*mass[iprt]*E.lab_MC[iprt]/1000.)); 
	pmom_MC[iprt] = plrz_MC[iprt].Vect();
	vel_MC[iprt] = pow(mass[iprt],-1)/plrz_MC[iprt].Gamma() *pmom_MC[iprt]; // velocity
      } // for iprt < 2
      // Ecm_MC_nr = Elab2cm(Elab2_MC, thlab2_MC, mres[iex], q2[iex]); // !
      // thcm_MC_nr = thlab2cm(Ecm_MC,thlab2_MC, mres[iex], q2[iex]); // !
      //Ecm_MC_rec = Elab2cm(E.lab2_MC, th.lab2_MC, mres[iex], q2[iex]);
      
      // Particle 3
      plrz_MC[2] = W_mid - plrz_MC[0] - plrz_MC[1];
      pmom_MC[2] = plrz_MC[2].Vect();
      vel_MC[2] = pow(mass[2],-1)/plrz[2].Gamma() *pmom[2]; // velocity
      // TVector3 pp3vec_MC = beam_mid.Vect() - pmom_MC[0] - pmom_MC[1]; // momentum conservation
      // E.lab_MC[2] = pp3vec_MC.Mag2()/2./mass[2]*1000.;
      E.lab_MC[2] = (plrz_MC[2].E() - mass[2])*1000.;
      // cout << E.lab[2] << " " << (plrz[2].E() - mass[2])*1000. << " "
      // 	   << E.lab_MC[2] << " " << (plrz_MC[2].E() - mass[2])*1000. << endl;
      th.lab_MC[2] = (plrz_MC[2].Theta())/d2r;
      phi.lab_MC[2] = (plrz_MC[2].Phi())/d2r;

      // Relative energy, E_cm, theta_cm, Q value
      for(Int_t iprt=0; iprt<3; iprt++){ // After plrz[iprt] are all defined...
	plrzsum_MC[iprt] = plrz_MC[iprt] + plrz_MC[(iprt+1)%3]; // (iprt+1)%3 = 1, 2, 0
	E.rel_MC[iprt] = (plrzsum_MC[iprt].M() - (mass[iprt] + mass[(iprt+1)%3]))*1000.; // MeV
      }
      E.cm_MC = E.rel_MC[0] - q2[iex]*1000.; // MeV
      th.cm_MC = theta_cm(mprj, mtrg, beam_mid, plrz_MC[2], vel_MC);
      p.spc_MC =  mom_spec(pmom_MC[2]); // in MeV/c, tartget breakup
      E.Q3_dec = E.lab_MC[0] + E.lab_MC[1] + E.lab_MC[2] - E.beam_dec;
      
      // E.cm_dev = E.cm - E.cm_MC;
      // th.cm_dev = th.cm - th.cm_MC;	
      geve++;
    } // if istate2
    //} // if eprj>0
    
    // w.efth = eff_thk(eprj);
    // if(E.cm_z < 0.36686) // Min. energy of NONSMOKER calc.
    //   w.hf = 0.;
    // else
    //   w.hf = interhf.Eval(E.cm_z);
    // w.yld = Ccs*w.hf; 
    //cout << w.efth << " " << w.hf << " " << w.yld << endl;
    
    //Double_t rnum = ran->Rndm();
    //if(rnum<=eff_thk(ps)){
    sim->Fill();	  
    //geve++;
    //}
    
    //    } // if istate2
    //i++;
    //cout << geve << "\n"; 
  } // for 
  fl2->Write();
  //fl2->Close();
  cout << "Number of coincidence events inside the detectors =" << geve << "\n"; 
  cout << "Total number of events =" << ntot << "\n";
  cout << "Done!" << "\n"; 
  //return 0;

  TView3D *view = (TView3D*)TView::CreateView(1);
  view->SetRange(-250,-250,-250,250,250,250);
  view->Front();
  view->ShowAxis();  
  //c0->Update();gSystem->ProcessEvents();getchar();
  //c0->Print("detector_array_sim01.png");
  
  theApp.Run();
  
  return 0;
  
}


    /* //pdir[0] = pmom[0].Unit(); // unit vector of the momentum */
    /* pdir[1] = pmom[1].Unit(); // represents the direction */
    /* xx[1] = pdir[1](0); */
    /* yy[1] = pdir[1](1); */
    /* zz[1] = pdir[1](2); */
    /* gGeoManager->SetCurrentPoint(pos.xtar,pos.ytar,pos.ztar); */
    /* gGeoManager->SetCurrentDirection(xx[1],yy[1],zz[1]); */
    /* //      TGeoNode *current2 = */
    /* gGeoManager->GetCurrentNode(); */
    /* gGeoManager->FindNode(); */
    /* gGeoManager->FindNextBoundary(radius); */
    /* snext[1] = gGeoManager->GetStep(); */
    /* //TGeoNode *newNode2 = */
    /* gGeoManager->Step(); */
    /* istate[1] = gGeoManager->IsStepEntering(); */
    /* idnode[1] = gGeoManager->GetCurrentNodeId(); */
    /* //Double_t safety2 = gGeoManager->GetSafeDistance(); */
    /* //cout << istate2 <<" "<< snext2 << endl; */
    /* path = gGeoManager->GetPath(); // /TOP_1/PSD_3 etc. */
    /* strncpy(sdet, path+11, 1); // extract the 12th character from path */
    /* sdet[1] = '\0'; */
    /* hitdet[1] = atoi(sdet); */
    /* //TVector3 vdet2(snext2*xx2,snext2*yy2,snext2*zz2);  */
    /* vdetprt[1].SetXYZ(snext[1]*xx[1],snext[1]*yy[1],snext[1]*zz[1]); */
    /* pos.ldetprt[1] = snext[1]; */
    
    // E.beam = E.beam_mid = E.beam_dec
    //   = E.lab[0] = E.lab[1] = E.lab[2]
    //   = E.lab_det[0] = E.lab_det[1]
    //   = E.lab_det_MC[0] = E.lab_det_MC[1]
    //   = E.lab_MC[0] = E.lab_MC[1]
    //   = dummy;
    // E.lab_DE[0] = E.lab_DE[1]
    //   = E.lab_DE_MC[0] = E.lab_DE_MC[1]
    //   = E.lab_RES[0] = E.lab_RES[1]
    //   = E.lab_RES_MC[0] = E.lab_RES_MC[1]
    //   = dummy;
    // th.lab[0] = th.lab[1] = th.lab[2]
    //   = phi.lab[0] = phi.lab[1] = phi.lab[2]
    //   = th.lab_MC[0] = th.lab_MC[1]
    //   = phi.lab_MC[0] = phi.lab_MC[1]
    //   = th.cm = th.cm_MC = th.cm_dev = 0.;
    // th.cm_MC_nr = 0.;

    // E.rel[0] = E.rel[1] = E.rel[2]
    //   = E.rel_MC[0] = E.rel_MC[1] = E.rel_MC[2]
    //   = E.cm = E.cm_z = E.cm_MC = E.cm_z_MC= E.cm_z0 = E.cm_dev
    //   = dummy; 
    //p.spc = dummy;

    // tof.beam = tof.beam_dec
    //   = tof.rec = tof.rec_MC
    //   = tof.de = tof.de_MC = dummy;
    //tof.dee = tof.e= tof.e_MC = dummy;a
    // for(Int_t i=0;i<ndet;i++){
    //   pos.xhit[0][i] = pos.yhit[0][i] = pos.xhit_MC[0][i] = pos.yhit_MC[0][i] = dummy;
    //   pos.xhit[1][i] = pos.yhit[1][i] = pos.xhit_MC[1][i] = pos.yhit_MC[1][i] = dummy;
    // }
    // for(Int_t i=0;i<ndet;i++)
    //   tel[i] = false; // initialization

    //hit.any = 0; // initialization
    // pos.xtar = pos.ytar = pos.rtar
    //   = pos.xtar_MC = pos.ytar_MC //= rtar_MC
    //   = pos.ldetprt[0] = pos.ldetprt[1]
    //   = pos.ldetprt_MC[0] = pos.ldetprt_MC[1] = dummy;

    //w.evt = 0.; //w.efth = w.hf = w.yld = 0.; 


    /* //-- Defining the reaction point --//     */
    /* // nran = ran->Rndm(); // 0-1 */
    /* // ztar = ltar*(nran-0.5); // 0 +/- ltar/2  // ! */
    /* // Uniform in Ebeam */
    /* eprjini = ran->Gaus(eprj0ini,deprj); // ! for now deprj is constant */
    /* eprj = ran->Uniform(0.,eprjini); */
    /* float z_beam = ebeam2thk(eprj*1000.,eprjini*1000.)/density/1000.*10.; */
    /* //cout << eprjini << " " << eprj << " " << z_beam << endl; */
    
    /* // pos.ztar = ran->Uniform(-ltar/2.,ltar/2.); // Reaction point, 10-nov-2021 */
    /* //float z_beam = pos.ztar + ltar/2.; // 0-ltar for enewz */
    /* pos.ztar = z_beam - ltar/2.; */
    /* //cout << pos.ztar << endl; */
    /* Ebfrpu_beam = eprj0ini/mprj*1000.; // MeV */
    /* enewzsub_(&zprj, &mprj, &Ebfrpu_beam, he, &unit_pressure, &pressure0, */
    /* 	      &temperature0, &unit_mm, &z_beam, &Eaftpu_beam); */
    /* eprj0 = Eaftpu_beam*mprj/1000.; // Mean beam energy at reaction point, GeV */
    /* E.beam_mid = eprj0*1000.; // MeV */
    /* E.cm_z0 = eprj0*mtrg/(mprj+mtrg)*1000.; // MeV */
    
    /* pressure = ran->Gaus(pressure0,dpressure); */
    /* temperature = ran->Gaus(temperature0,dtemperature); */
    /* gas.prs0 = double(pressure0); */
    /* gas.prs = double(pressure); */
    /* gas.tmp0 = double(temperature0); */
    /* gas.tmp = double(temperature); */

    /* // eprjini = ran->Gaus(eprj0ini,deprj); // ! for now deprj is constant */
    /* // Ebfrpu_beam = eprjini/mprj*1000.; // MeV */
    /* // enewzsub_(&zprj, &mprj, &Ebfrpu_beam, he, &unit_pressure, &pressure, */
    /* // 	      &temperature, &unit_mm, &z_beam, &Eaftpu_beam); */
    /* //    eprj = Eaftpu_beam*mprj/1000.; // Deviated beam energy at reaction point, GeV */
    /* E.beam = eprj*1000.; // MeV */
    /* E.cm_z = eprj*mtrg/(mprj+mtrg)*1000.; // MeV */
    // cout << pos.ztar << " " << E.beam_mid << " " << E.beam
    // 	 << " " << E.cm_z0 << " " << E.cm_z << endl;

      /* if( E.cm>2. && E.lab2_det>0. && E.lab2_det_MC>0. */
      /*    && !isnan(z_beam) && !isnan(z_beam_dec) */
      /*    && !isnan(pos.ldetprt) && !isnan(pos.ldetprt_MC) ){ */
      /*   //if(E.cm>1.){ */
      /*   // TOF calucluation */
      /*   Ebfrpu_beam = eprjini/mprj*1000.; // beam energy at entrance, MeV  */
      /*   fint->SetParameters(zprj,mprj,Ebfrpu_beam); */
      /*   tof.beam = fint->Integral(0.,z_beam,1e-4);	   */
      /*   // if(isnan(tof.beam)){ */
      /*   //   cout << "Beam: " << Ebfrpu_beam <<" " << z_beam << " " << tof.beam << endl; */
      /*   //   getchar(); */
      /*   // } */
      
      /*   // TOF calucluation, with resolution */
      /*   //float z_beam_dec = ztar_MC + ltar/2.; */
      /*   //Eaftpu_beam = Ebfrpu_beam; // beam energy at reaction point, MeV */
      /*   // Eaftpu_beam = Ebeam_dec/mprj; // beam energy at reaction point, MeV */
      /*   // eoldzsub_(&zprj, &mprj, &Eaftpu_beam, he, &unit_pressure, &pressure,  */
      /*   // 	    &temperature, &unit_mm, &z_beam_dec, &Ebfrpu_beam); */
      /*   Ebfrpu_beam = eprj0ini/mprj*1000.; // beam energy at entrance, MeV  */
      /*   fint->SetParameters(zprj,mprj,Ebfrpu_beam); */
      /*   tof.beam_dec = fint->Integral(0.,z_beam_dec,1e-4); */
      /*   // if(isnan(tof.beam_dec)){ */
      /*   //   cout << "Beam resol: " << Ebfrpu_beam <<" " << z_beam_dec << " " << tof.beam_dec << endl; */
      /*   //   getchar(); */
      /*   // } */
      
      /*   // TOF calucluation */
      /*   Ebfrpu = E.lab[1]/mrec; */
      /*   fint->SetParameters(zrec,mrec,Ebfrpu); */
      /*   tof.rec = fint->Integral(0.,pos.ldetprt,1e-4); */
      /*   // if(isnan(tof.rec)){ */
      /*   //   cout << "Rec: " << Ebfrpu <<" " << pos.ldetprt << " " << tof.rec << endl; */
      /*   //   getchar(); */
      /*   // } */
      
      /*   // TOF calucluation, with resolution */
      /*   //Ebfrpu = Elab[1]/mrec; */
      /*   Ebfrpu = E.lab2_MC/mrec; */
	/*   fint->SetParameters(zrec,mrec,Ebfrpu); */
	/*   //float fldetprt_MC = float(ldetprt_MC); */
	/*   tof.rec_MC = fint->Integral(0.,pos.ldetprt_MC,1e-4); */
	/*   // if(isnan(tof.rec_MC)){ */
	/*   //   cout << "Rec resol: " << Ebfrpu <<" " << pos.ldetprt_MC << " " << tof.rec_MC << endl; */
	/*   //   getchar(); */
	/*   // } */
	  
	/*   // DE layer */
	/*   Ebfrpu = E.lab2_det/mrec; // Energy in front of DE (MeV) */
	/*   enewzsub_(&zrec, &mrec, &Ebfrpu, si, &unit_pressure, &pressure,  */
	/* 	    &temperature, &unit_mm, &de_thick, &Eaftpu); */
	/*   E.lab2_DE = (Ebfrpu - Eaftpu)*mrec; // Energy in DE */
	/*   //DElab2_MC = ran->Gaus(DElab2,DElab2*depe2); */
	/*   E.lab2_DE_MC = ran->Gaus(E.lab2_DE, // based on resolution at 5 MeV */
	/* 			     sqrt(5.*E.lab2_DE)*depe2); */
	  
	/*   Ebfrpu = Eaftpu; // Energy after DE */
	/*   enewzsub_(&zrec, &mrec, &Ebfrpu, he, &unit_pressure, &pressure,  */
	/* 	  &temperature, &unit_mm, &int_det, &Eaftpu);	 */
	/*   E.lab2_RES = Eaftpu*mrec; // Energy before E */
	/*   E.lab2_RES_MC = ran->Gaus(E.lab2_RES, // based on resolution at 5 MeV */
	/* 			   sqrt(5.*E.lab2_RES)*depe2); */
	/*   //cout << "5" << endl; getchar(); */
	/*   // if(Eaftpu > 0.){ */
	/*   //   fint->SetParameters(zrec,mrec,Ebfrpu); */
	/*   //   tofdee = fint->Integral(0.,int_det,1e-3); */
	/*   // } */
	/*   tof.de = tof.beam + tof.rec; // TOF up to DE layer */
	/*   tof.de_MC = ran->Gaus(tof.beam_dec + tof.rec_MC,dt); */
	  // tofe = tofde + tofdee; // TOF up to E layer
	  // tofe_MC = ran->Gaus(tofe,dt);
      //}// if(Elab2_det>0)




      // /* // Newton's method */
      // const Int_t nlim = 10;
      // const Double_t dztar = .2;
      // const Double_t eps = 1.e-4;
      // float fldetprt_MC, z_beam_dec;
      // pos.ztar_MC = pos.ztar;
      // Ebfrpu_beam = eprj0ini/mprj*1000.;
      // Eaftpu = E.lab2_det_MC/mrec; // MeV
      // Double_t eprj0_MC = eprj0; // initial value
      // //cout << eprj0_MC*1000. << endl;
      // Double_t Ecm_MC_beam, Ecm_MC_beam_p, Ecm_MC_beam_m,
      //   Ecm_MC_rec, Ecm_MC_rec_p, Ecm_MC_rec_m;
      // //cout << "2" << endl; getchar();
      // if(!isnan(Elab2cm(E.lab[1], th.lab[1], mres[iex], q2[iex]))){
      // //   cout << E.cm << " " << Elab2cm(E.lab[1], th.lab[1], mres[iex], q2[iex]) << endl; getchar();
      // //   E.beam_dec = E.beam_mid;
      // //   E.cm_z_MC = E.cm_z;
      // //   E.cm_MC = E.cm;
      // //   pos.ldetprt_MC = pos.ldetprt;
      // //   phi.lab2_MC = phi.lab[1];
      // // }else{
      //   for(Int_t i=0; i<nlim; i++){ // no. of trials for Newton's method
      //     // Ecm from recoil energy at z
      // 	  //          Ecm_MC_beam = eprj0_MC*mtrg/(mprj+mtrg)*1000.; // Ecm from beam energy
      
      
      //     // cout << i << " " << eprj0_MC*1000. << " " << ztar_MC
      //     //      << " " << Ecm_MC_beam << " " << Ecm_MC_rec << endl;
      
      //     if(2.*fabs(Ecm_MC_beam - Ecm_MC_rec)/(Ecm_MC_beam + Ecm_MC_rec) < eps){
      //       //cout << 2.*fabs(Ecm_MC_beam - Ecm_MC_rec)/(Ecm_MC_beam + Ecm_MC_rec) << endl;
      //       break;
      //     }
      //     // Ecm from recoil energy at z+dz
      //     z_beam_dec = pos.ztar_MC+dztar + ltar/2.;
      //     enewzsub_(&zprj, &mprj, &Ebfrpu_beam, he, &unit_pressure, &pressure0,
      // 	      &temperature0, &unit_mm, &z_beam_dec, &Eaftpu_beam);
      //     //cout << i << " " << Ebfrpu_beam << " " << z_beam_dec << " " << Eaftpu_beam;
      //     Ecm_MC_beam_p = Eaftpu_beam*mprj*mtrg/(mprj+mtrg);
      
      //     vreac_MC.SetXYZ(pos.xtar_MC,pos.ytar_MC,pos.ztar_MC+dztar);
      //     vdetprt_MC = vhit_MC + vdet[hit.idet] - vreac_MC;
      //     fldetprt_MC = float(vdetprt_MC.Mag());
      //     eoldzsub_(&zrec, &mrec, &Eaftpu, he, &unit_pressure, &pressure0,
      // 	      &temperature0, &unit_mm, &fldetprt_MC, &Ebfrpu);
      //     E.lab2_MC = Ebfrpu*mrec; // MeV
      //     th.lab2_MC = (vdetprt_MC.Theta())/d2r;
      //     Ecm_MC_rec_p = Elab2cm(E.lab2_MC, th.lab2_MC, mres[iex], q2[iex]);
      
      //     // Ecm from recoil energy at z-dz
      //     z_beam_dec = pos.ztar_MC-dztar + ltar/2.;
      //     enewzsub_(&zprj, &mprj, &Ebfrpu_beam, he, &unit_pressure, &pressure0,
      // 	      &temperature0, &unit_mm, &z_beam_dec, &Eaftpu_beam);
      //     //cout << " " << Ebfrpu_beam << " " << z_beam_dec << " " << Eaftpu_beam; // << endl;
      //     Ecm_MC_beam_m = Eaftpu_beam*mprj*mtrg/(mprj+mtrg);
      
      //     vreac_MC.SetXYZ(pos.xtar_MC,pos.ytar_MC,pos.ztar_MC-dztar);
      //     vdetprt_MC = vhit_MC + vdet[hit.idet] - vreac_MC;
      //     fldetprt_MC = float(vdetprt_MC.Mag());
      //     eoldzsub_(&zrec, &mrec, &Eaftpu, he, &unit_pressure, &pressure0,
      // 	      &temperature0, &unit_mm, &fldetprt_MC, &Ebfrpu);
      //     E.lab2_MC = Ebfrpu*mrec; // MeV
      //     th.lab2_MC = (vdetprt_MC.Theta())/d2r;
      //     Ecm_MC_rec_m = Elab2cm(E.lab2_MC, th.lab2_MC, mres[iex], q2[iex]);
      
      //     // differential (f(z) = E_beam - E_rec)
      //     Double_t dEcmdz = (Ecm_MC_beam_p - Ecm_MC_rec_p
      // 		       - Ecm_MC_beam_m + Ecm_MC_rec_m)
      //       /2./dztar;
      //     // cout << i
      //     //      << " " << pos.ztar_MC
      //     //      << " " << fldetprt_MC
      //     //      << " " << Eaftpu*mrec      << " " << E.lab2_MC
      //     //      << " " << th.lab2_MC
      //     //      << " " << Ecm_MC_beam_p << " " << Ecm_MC_beam_m
      //     //      << " " << Ecm_MC_rec_p  << " " << Ecm_MC_rec_m
      //     //      << " " << dEcmdz
      //     //      << " " << (Ecm_MC_beam - Ecm_MC_rec)/dEcmdz
      //     //      << " " << 2.*fabs(Ecm_MC_beam - Ecm_MC_rec)/(Ecm_MC_beam + Ecm_MC_rec)
      //     //      << endl; getchar();
      //     pos.ztar_MC -= (Ecm_MC_beam - Ecm_MC_rec)/dEcmdz;
      
      //     // For Ebeam at next ztar_MC
      //     z_beam_dec = pos.ztar_MC + ltar/2.;
      //     enewzsub_(&zprj, &mprj, &Ebfrpu_beam, he, &unit_pressure, &pressure0,
      // 	      &temperature0, &unit_mm, &z_beam_dec, &Eaftpu_beam);
      //     eprj0_MC = Eaftpu_beam*mprj/1000.;
      //     // cout << " " << Ebfrpu_beam << " " << z_beam_dec << " " << Eaftpu_beam
      //     //      << " " << dEcmdz << endl;
      //   }
      //   E.beam_dec = eprj0_MC*1000.;
      //   E.cm_z_MC = eprj0_MC*mtrg/(mprj+mtrg)*1000.;
      //   E.cm_MC = (Ecm_MC_beam + Ecm_MC_rec)/2.;
      //   pos.ldetprt_MC = vdetprt_MC.Mag();
      //   phi.lab2_MC = (vdetprt_MC.Phi())/d2r;
      // }
      
      
    // TVector3 vprj = pow(u*mprj,-1)/beam_dec.Gamma() *(beam_dec.Vect()); // velocity 
    // TLorentzVector ptran = - plrz[2]; // 4-momentum of the transferred particle 
    // TVector3 vtran = 1./sqrt(pow(mtrg*u - plrz[2].Energy(),2) + pmom[2].Mag2())
    //   /ptran.Gamma() *ptran.Vect(); // velocity, See Slaus et al
    // TVector3 ki = vprj; - vtran; // target breakup 13-11-2017
    // TVector3 kf = vel[0] - vel[1]; // Final relative velocity (1<->2); vel[0] is beamlike (heavy ion)
    // th.cm = (ki.Angle(kf))/d2r;
